use num::Num;

#[derive(Copy, Clone)]
pub struct Vec2<T : Num + Copy> {
    pub x: T,
    pub y: T,
}

impl<T : Num + Copy> Vec2<T> {
    pub fn zero() -> Self {
        Vec2 {x: T::zero(), y: T::zero()}
    }
}

impl<T : Num + Copy + Default> Default for Vec2<T> {
    fn default() -> Self {
        Vec2 {
            x: T::default(),
            y: T::default()
        }
    }
}